/* fp is the file the output goes to
 * data is the data to be hexdumped, in memory
 * data_len is the length of data in memory
 * ptr is the start of the data to be hexdumped
 *
 * So, bytes numbered ptr ... data_len-1 are to be hexdumped.
 */

/* Prototypes: */
int hexdmp(FILE *fp, unsigned char *data, int data_len, int ptr);
int output_dump_char(char *line, int ch);


/* Functions: */
int output_dump_char(char *line, int ch) {
	int j = strlen(line);

	if (use_html) {
		switch (ch) {
		case '<': sprintf(&line[ j ], "&lt;"); break;
		case '>': sprintf(&line[ j ], "&gt;"); break;
		case '&': sprintf(&line[ j ], "&amp;"); break;
		default:
			if (ch < 32 || ch > 126) {
				/* control characters */
				strcat(line, "<span class=\"control_chars\">");
				j = strlen(line);
				sprintf(&line[ j ], ".");
				strcat(line, "</span>"); /* Colour off */
			}
			else {
				line[ j ] = ch;
				line[ j+1 ] = 0;
			}
			break;
		}
	}
	else {
		if (ch < 32 || ch > 126) {
			/* control characters */
			sprintf(&line[ j ], ".");
		}
		else {
			line[ j ] = ch;
			line[ j+1 ] = 0;
		}
	}

	if (j+1 > 1000) { /* This should never occur, see other check for output length */
		fprintf(stderr, "program error in bbclist: line too long\n");
		return -1;
	}
	return 0;
}


int hexdmp(FILE *fp, unsigned char *data, int data_len, int ptr) {
	int  adres;
	char line[100];
	char ascii[41];
	int ascii_i;

	adres = ptr+1;
//    adres = ftell(fp);

	for (;;) {
		unsigned char byte;
		int start = adres & 7;
		int end;
		int i;

		/* create hex and ascii strings */
		for (i=0; i<3*8; i++) line[i]=' ';
		line[3*8] = 0;
		for (i=0; i<8; i++) ascii[i]=' ';

		ascii[ start ] = 0;
		for (i=start; i<8; i++) {
//			fread(&byte, 1, 1, fp);
//			if (feof(fp)) break;
			if (adres >= data_len) break;
			byte = data[ adres ];
			adres++;

			sprintf(line+3*i, "%02X ", byte);

			ascii_i = strlen(ascii);
			if (use_html) {
				char ch = byte;
				switch (ch) {
				case '<': sprintf(&ascii[ ascii_i ], "&lt;"); break;
				case '>': sprintf(&ascii[ ascii_i ], "&gt;"); break;
				case '&': sprintf(&ascii[ ascii_i ], "&amp;"); break;
				default:
					if (byte < 32 || byte > 126) sprintf(&ascii[ ascii_i ], ".");
					else {
						ascii[ ascii_i ] = ch;
						ascii[ ascii_i+1 ] = 0;
					}
					break;
				}
			}
			else {
				if (byte < 32 || byte > 126) ascii[i] = '.';
				else ascii[i] = byte;
				ascii[i+1] = 0;
			}

		}
		end = i-1;
		if (end >= start) {
			int  j;
			fprintf(fp, "%04X  ", adres -(end-start+1) /* -end-1 */);
			fprintf(fp, "%s", line);
			for (j=0; j<7-end; j++) fprintf(fp, "   ");
			fprintf(fp, "   ");
			fprintf(fp, "%s", ascii);
			fprintf(fp, "\n");
		}

//		if (feof(fp)) break;
		if (adres >= data_len) break;
	}

	return 0;
}
